#%RAML 1.0
title: Web sirius
version: v0.1
protocols: [ HTTP ]
baseUri: http://sirius.utp.edu.co/api/{version}
mediaType:  application/json
types:
  User:
    type: object
    properties:
      _id: string #id automatic
      username: string
      name: string
      lastName: string
      email: string
      password: string
      professionalProfile:
        type: array
        items: string
      status:
        type: array
        items: string
      photo?: file
      cv?: file
  Stakeholder:
    type: object
    properties:
      name: string
      _id?: string
  Project:
    type: object
    properties:
      type: 
        type: array
        items: string
      status: string
      stakeholders:
        type: array
        items: Stakeholder
        uniqueItems: true
      imagePath: string
      summary: string
      report: string
/session:
  post:
    description: Creates a session token
    responses:
      200:
        body:
          application/json:
            example:
              {"token": "aaaaaaaaaa.bbbbbbbbbbb.cccccccccccc"}
      500:
        body:
          application/json:
            example:
              {"message": "Server problem"}
      401:
        body:
          application/json:
            example:
              {"message": "Login authentication failed"}
/users:
  get:
    description: Return all users registered
    responses:
      200:
        body:
          application/json:
            type: User[]
      500:
        body:
          application/json:
            example: |
                {"message": "Server problem"}
  post:
    description: Creates a new user
    responses:
      201:
        body:
          type: User
      500:
        body:
          application/json:
            example: |
                {"message": "Problem creating user"}
  /{username}:
    get:
      description: Returns an user with specific username
      responses:
        200:
          body:
            application/json:
             type: User
        404:
          body:
            application/json:
              example: |
                {"message": "Users not found"}
    put:
      description: Updates an specific user
      body:
        application/json:
          type: User
      responses:
        200:
          body:
            type: User
        500:
          body:
            application/json:
              example: |
                {"message": "Internal server problem"}
    delete:
      description: Eliminates a user with specific username
      responses:
        202:
          body:
            application/json:
                example: |
                  {"message": "The delete was successful"}
        404:
          body:
            application/json:
              example: |
                {"message": "User not found or invalid"}
    /projects:
      description: All project from a user
      get:
        description: Return all project from a user
        responses:
          200:
            body:
              application/json:
                type: Project[]
          500:
            body:
              application/json:
                example: |
                  {"message": "Internal server problem"}
/projects:
  description: Projects in Sirius laboratory
  get:
    description: Return all projects
    responses:
      200:
        body:
          application/json:
            type: Project[]
      500:
        body:
          application/json:
            example: |
                {"message": "Server problem"}
  post:
    description: Creates a new project
    responses:
      200:
        body:
          type: Project
      500:
        body:
          application/json:
            example: |
                {"message": "Problem creating project"}
  /{_id}:
    get:
      description: Return a project with specific id
      responses:
        200:
          body:
            application/json:
              type: Project
    put:
      description: Updates an specific project
      body:
        application/json:
          type: Project
      responses:
        200:
          body:
            type: Project
        500:
          body:
            application/json:
              example: |
                {"message": "Internal server problem"}
    delete:
      description: Eliminates a project with specific id
      responses:
        202:
          body:
            application/json:
                example: |
                  {"message": "The delete was successful"}
        404:
          body:
            application/json:
              example: |
                {"message": "Project not found or invalid"}
    /users:
      description: Stakeholders from a project
      get:
        description: Return all Stakeholders from project
        responses:
          200:
            body:
              application/json:
                type: Stakeholder[]